/**
    \file CThread.cpp
    \author Kurt Stege

    Thread Abstraction

    History:

    (ks) = Kurt Stege, kurt-stege@online.de

    2005-08-23 (ks):    File created.
    2005-08-23 (ks):    Current version.
*/

#ifndef _MSC_VER
#error "This implementation file assumes to be compiled for Win32 using MSVC."
#endif

#include "Base/CThread.hpp"

#include <assert.h>

#include "windows.h"


#ifdef _MSC_VER
typedef void threadfunction (void *);

struct tArgumentsForStartThread
{
    NBase::CThread::tFunction *func;
    void *par;
};

static DWORD WINAPI win_startThread(LPVOID par)
{
    tArgumentsForStartThread args = *(static_cast<tArgumentsForStartThread *>(par));
    delete par;
    args.func(args.par);
    return 0;
}
 

void NBase::CThread::createThread (tFunction *func, void *par)
{
    tArgumentsForStartThread *args = new tArgumentsForStartThread;
    args->func = func;
    args->par = par;

    LPDWORD dummy = 0;
    HANDLE threadhandle = CreateThread(0, 0, win_startThread, args, 0, dummy);
}

void NBase::CThread::sleep (long milliseconds)
{
    Sleep (milliseconds);
}

#endif



